#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>


extern char **environ;


/* Try to read from a bunch of file descriptors. */
void print_fds(void) {
      int i;
      ssize_t r;
      char bfr [81];

      printf("Trying to read from files > 2:\n");

      for (i = 3; i < 100; i++) {
            r = read(i, bfr, sizeof(bfr) - 1);

            if (-1 == r && EBADF != errno) {
                  printf("BAD: Could not read from fd %d (errno %d), but it is present!\n",
                         i, errno);
            }
            else if (-1 != r) {
                  bfr[r] = '\0';
                  printf("BAD! Read from fd %d: %s\n", i, bfr);
            }
      }
}


#define GroupCount 1000

/* Print group list. */
void print_groups(void) {
      int i, group_count;
      gid_t groups [GroupCount];

      printf("Supplemental groups (should be none): ");

      group_count = getgroups(GroupCount, groups);
      if (-1 == group_count) {
            printf("BAD: isolatee is a member of more than %d groups!\n", GroupCount);
            return;
      }

      for (i = 0; i < group_count; i++)
            printf("%u ", groups[i]);
      printf("\n");
}


/* Print every environment variable we have in enivron. */
void print_env(void) {
      char **env_ptr;

      printf("Environment:\n");

      for (env_ptr = environ; env_ptr && *env_ptr; env_ptr++)
            printf("      %s\n", *env_ptr);
}


int main(void) {
      printf("uid: %u, euid: %u, gid: %u, egid: %u\n", getuid(), geteuid(), getgid(), getegid());
      print_groups();

      /* Die zug kommt an!
      getresuid();
      getresgid();
      getfsuid();
      getgroups();
      getpid();
      getsid();
      // Print capabilities here... (linux version currently)
      capgetp();
      printf("Attempting chroot break...\n");
      // Ensure that we can't break out of the chroot - look for open FDs, etc
      printf("Did we link against any evil things?\n");
      // Do we have any symlinks to exploit?
      printf("\n");
      // ddz suggests: "SysV IPC, sysctl, other misc. system calls."
      // Mario suggests: "backdoor the gnome menu"
      // dbph suggests: "dos the system" (eg: exceed the rlimits of the system)
      // mdowd was sent back from the future with this suggestion:
      "Basically agreee with dino on syscalls - execing certain other progs"
      "(suid ones?), restrictions on network connectivity, etc"
      */ 

      print_env();

      print_fds();

      return 0;
}

